package cn.superdesk.uniorder.executor.scheduler.utils;


import cn.superdesk.uniorder.common.spring.SpringContextHolder;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.util.ReflectionUtils;

import java.lang.reflect.Method;
import java.util.concurrent.Callable;


/**
 * @Description: Java类作用描述
 * @Author: linjinyu
 * @CreateDate: 2020/12/23 上午10:24
 * @UpdateUser: linjinyu
 * @UpdateDate: 2020/12/23 上午10:24
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Slf4j
public class QuartzRunnable implements Callable {

	private Object target;
	private Method method;
	private String params;

	QuartzRunnable(String beanName, String methodName, String params) throws NoSuchMethodException, SecurityException {

		// TODO 可能存在问题 先标记
		this.target = SpringContextHolder.getBean(beanName);
		this.params = params;

		if (StringUtils.isNotBlank(params)) {
			this.method = target.getClass().getDeclaredMethod(methodName, String.class);
		} else {
			this.method = target.getClass().getDeclaredMethod(methodName);
		}
	}

	@Override
	public Object call() throws Exception {

		ReflectionUtils.makeAccessible(method);

		if (StringUtils.isNotBlank(params)) {
			method.invoke(target, params);
		} else {
			method.invoke(target);
		}

		return null;
	}
}
